'CC.inc

Declare Function CoRegisterClassObjectPtr Lib "OLE32.DLL" Alias "CoRegisterClassObject" _
( _
  Byref rclsid       As Guid, _
  Byval pUnknown     As Dword, _
  Byval dwClsContext As Dword, _
  Byval flags        As Dword, _
  ByRef lpdwRegister As Dword _
) As Long                
 
                          'IClassFactory1 Interface Function Pointers
Declare Function          ptrCreateInstance (Byval this As Dword, Byval pUnk As Dword, Byref iid As Guid, Byref ppv As Dword) As Long
Declare Function          ptrLockServer     (Byval this As Dword, Byval blnLock As Long                                     ) As Long

                          'IX, IY Interface Function Pointer Prototypes
Declare Function          ptrQueryInterface (Byval this As Dword, Byref iid As Guid, Byref pUnknown As Dword                ) As Long
Declare Function          ptrAddRef         (Byval this As Dword                                                            ) As Dword
Declare Function          ptrRelease        (Byval this As Dword                                                            ) As Dword
Declare Function          ptrSetInt         (Byval this As Dword, Byval iVal As Long                                        ) As Long
Declare Function          ptrGetInt         (Byval this As Dword, Byref pVal As Long                                        ) As Long
Declare Function          ptrSetText        (Byval this As Dword, Byval strText As String                                   ) As Long
Declare Function          ptrGetText        (Byval this As Dword, Byref ptrText As String                                   ) As Long

$IID_IClassFactory        =  Guid$("{00000001-0000-0000-C000-000000000046}")
$IID_IUnknown             =  Guid$("{00000000-0000-0000-C000-000000000046}")
$CLSID_CC                 =  Guid$("{20000000-0000-0000-0000-000000000020}")
$IID_IX                   =  Guid$("{20000000-0000-0000-0000-000000000021}")
$IID_IY                   =  Guid$("{20000000-0000-0000-0000-000000000022}")
$LIBID_CCLibrary          =  Guid$("{20000000-0000-0000-0000-000000000023}")

Type IXVtbl
  QueryInterface          As Dword Ptr
  AddRef                  As Dword Ptr
  Release                 As Dword Ptr
  SetXInt                 As Dword Ptr
  GetXInt                 As Dword Ptr
  SetXText                As Dword Ptr
  GetXText                As Dword Ptr
End Type

Type I_X
  lpIX                    As IXVtbl Ptr
End Type

Type IYVtbl
  QueryInterface          As Dword Ptr
  AddRef                  As Dword Ptr
  Release                 As Dword Ptr
  SetYInt                 As Dword Ptr
  GetYInt                 As Dword Ptr
  SetYText                As Dword Ptr
  GetYText                As Dword Ptr
End Type

Type I_Y
  lpIY                    As IYVtbl Ptr
End Type

Type CC
  lpIX                    As IXVtbl Ptr
  lpIY                    As IYVtbl Ptr
  m_iXInt                 As Long
  m_iYInt                 As Long
  m_XText                 As Dword Ptr
  m_YText                 As Dword Ptr
  m_cRef                  As Long
End Type

Type IClassFactoryVtbl
  QueryInterface          As Dword Ptr
  AddRef                  As Dword Ptr
  Release                 As Dword Ptr
  CreateInstance          As Dword Ptr
  LockServer              As Dword Ptr
End Type

Type IClassFactory1
  lpVtbl                  As IClassFactoryVtbl Ptr
End Type

Global g_szFriendlyName   As Asciiz*64
Global g_szVerIndProgID   As Asciiz*64
Global g_szProgID         As Asciiz*64
Global CCClassFactory     As IClassFactory1     'sizeof() =  4
Global IClassFactory_Vtbl As IClassFactoryVtbl  'sizeof() = 20
Global IX_Vtbl            As IXVtbl             'sizeof() = 28
Global IY_Vtbl            As IYVtbl             'sizeof() = 28
Global g_hModule          As Dword
Global g_lLocks           As Long
Global pIX                As Dword Ptr
Global pIY                As Dword Ptr
Global hMainWnd           As Dword


Sub CCLock()
  Print "  Entering CCLock()"
  Print "    g_lLocks = " g_lLocks
  Call InterlockedIncrement(g_lLocks)
  Print "    g_lLocks = " g_lLocks
  Print "  Leaving CCLock()"
End Sub


Sub CCUnLock()
  If g_lLocks > 0 Then
     Print "Entering CCUnLock()"
     Print "  g_lLocks = " g_lLocks
     Call InterlockedDecrement(g_lLocks)
     Print "  g_lLocks = " g_lLocks
     If g_lLocks=0 Then
        If hMainWnd Then
           Call PostQuitMessage(0)
           Call SendMessage(hMainWnd, %WM_CLOSE, 0, 0)
        End If   
     End If   
  Print "Leaving CCUnLock()"
  End If   
End Sub


Function IX_QueryInterface(ByVal this As I_X Ptr, ByRef iid As Guid, ByVal ppv As Dword Ptr) As Long
  @ppv=%NULL
  Select Case iid
    Case $IID_IUnknown
      Print "  Called IX_QueryInterface() For IID_IUnknown And this=" this
      @ppv=this
      Call IX_AddRef(this)
      Function=%S_OK
      Exit Function
    Case $IID_IX
      Print "  Called IX_QueryInterface() For IID_IX And this=" this
      @ppv=this
      Call IX_AddRef(this)
      Function=%S_OK
      Exit Function
    Case $IID_IY
      Print "  Called IX_QueryInterface() For IID_IY And this=" this
      Incr this
      @ppv=this
      Call IY_AddRef(this)
      Function=%S_OK
      Exit Function
    Case Else
      Print "Called IX_QueryInterface()"
  End Select

  Function=%E_NoInterface
End Function


Function IX_AddRef(ByVal this As I_X Ptr) As Long
  Local pCC As CC Ptr

  Print "Called IX_AddRef()"
  pCC=this
  Incr @pCC.m_cRef

  IX_AddRef=@pCC.m_cRef
End Function


Function IX_Release(ByVal this As I_X Ptr) As Long
  Local pCC As CC Ptr

  pCC=this
  Decr @pCC.m_cRef
  If @pCC.m_cRef=0 Then
     Call CoTaskMemFree(this)
     Print "Called IX_Release() And CC Was Deleted!"
     Call CCUnLock()
  Else
     Print "Called IX_Release()"
  End If

  Function=@pCC.m_cRef
End Function


Function SetXInt(ByVal this As I_X Ptr, Byval iXVal As Long) As Long
  Local pCC As CC Ptr

  Print "Called SetXInt(" & Trim$(Str$(iXVal)) & ")"
  pCC=this
  @pCC.m_iXInt=iXVal

  Function=%S_OK
End Function


Function GetXInt(ByVal this As I_X Ptr, Byref pXVal As Long) As Long
  Local pCC As CC Ptr

  pCC=this
  pXVal=@pCC.m_iXInt
  Print "Called GetXInt(" & Trim$(Str$(pXVal)) & ")"

  Function=%S_OK
End Function


Function SetXText(ByVal this As I_X Ptr, Byval strXText As String) As Long
  Local pCC As CC Ptr

  Print "Setting IXText To " & strXText
  pCC=this
  If SysReAllocString(@pCC.m_XText, Byval Strptr(strXText)) Then
     Function=%S_OK
  Else
     Function=%S_FALSE
  End If
End Function


Function GetXText(ByVal this As I_X Ptr, Byref strXText As String) As Long
  Local pCC As CC Ptr

  pCC=this
  If SysReAllocString(strXText, Byval @pCC.m_XText) Then
     Function=%S_OK
  Else
     Function=%S_FALSE
  End If
  Print "IX Text: " & strXText
End Function


Function IY_QueryInterface(ByVal this As I_Y Ptr, ByRef iid As Guid, ByVal ppv As Dword Ptr) As Long
  @ppv=%NULL
  Select Case iid
    Case $IID_IUnknown
      Print "Called IY_QueryInterface() For IID_IUnknown"
      Decr this
      @ppv=this
      Call IX_AddRef(this)
      Function=%S_OK
      Exit Function
    Case $IID_IX
      Print "Called IY_QueryInterface() For IID_IX"
      Decr this
      @ppv=this
      Call IX_AddRef(this)
      Function=%S_OK
      Exit Function
    Case $IID_IY
      Print "Called IY_QueryInterface() For IID_IY"
      @ppv=this
      Call IY_AddRef(this)
      Function=%S_OK
      Exit Function
    Case Else
      Print "Called IY_QueryInterface()"
  End Select

  Function=%E_NoInterface
End Function


Function IY_AddRef(ByVal this As I_Y Ptr) As Long
  Local pCC As CC Ptr

  Print "Called IY_AddRef() - this = " this
  Decr this
  pCC=this
  Incr @pCC.m_cRef

  IY_AddRef=@pCC.m_cRef
End Function


Function IY_Release(ByVal this As I_Y Ptr) As Long
  Local pCC As CC Ptr

  Decr this
  pCC=this
  Decr @pCC.m_cRef
  If @pCC.m_cRef=0 Then
     Call CoTaskMemFree(this)
     Print "Called IY_Release() And CC Was Deleted!"
     Call CCUnLock()
  Else
     Print "Called IY_Release()"
  End If

  Function=@pCC.m_cRef
End Function


Function SetYInt(ByVal this As I_Y Ptr, Byval iYVal As Long) As Long
  Local pCC As CC Ptr

  Print "Called SetYInt(" & Trim$(Str$(iYVal)) & ")"
  Decr this
  pCC=this
  @pCC.m_iYInt=iYVal

  Function=%S_OK
End Function


Function GetYInt(ByVal this As I_Y Ptr, Byref pYVal As Long) As Long
  Local pCC As CC Ptr

  Decr this
  pCC=this
  pYVal=@pCC.m_iYInt
  Print "Called GetXInt(" & Trim$(Str$(pYVal)) & ")"

  Function=%S_OK
End Function


Function SetYText(ByVal this As I_Y Ptr, Byval strYText As String) Export As Long
  Local pCC As CC Ptr

  Print "Setting IYText To " & strYText
  Decr this
  pCC=this
  If SysReAllocString(@pCC.m_YText, Byval Strptr(strYText)) Then
     Function=%S_OK
  Else
     Function=%S_FALSE
  End If
End Function


Function GetYText(ByVal this As I_Y Ptr, Byref strYText As String) Export As Long
  Local pCC As CC Ptr

  Decr this
  pCC=this
  If SysReAllocString(strYText, Byval @pCC.m_YText) Then
     Function=%S_OK
  Else
     Function=%S_FALSE
  End If
  Print "IY Text: " & strYText
End Function


Function CCClassFactory_QueryInterface(ByVal this As IClassFactory1 Ptr, ByRef RefIID As Guid, ByVal pCF As Dword Ptr) As Long
  Print "Called CCClassFactory_QueryInterface()"
  If RefIID=$IID_IUnknown Or RefIID=$IID_IClassFactory Then
     Call CCClassFactory_AddRef(this)
     @pCF=this
     Print "  Leaving CCClassFactory_QueryInterface()"
     Function=%NOERROR
     Exit Function
  End If

  Function=%E_NoInterface
End Function


Function CCClassFactory_AddRef(ByVal this As IClassFactory1 Ptr) As Long
  Print "Called CCClassFactory_AddRef()!"
  'Print "    Leaving CCClassFactory_AddRef()!"
  CCClassFactory_AddRef=10
End Function


Function CCClassFactory_Release(ByVal this As IClassFactory1 Ptr) As Long
  Print "Called CCClassFactory_Release()!"
  'Print "    this=" this
  'Print "  Leaving CCClassFactory_Release()!"
  CCClassFactory_Release=20
End Function


Function CCClassFactory_CreateInstance(ByVal this As IClassFactory1 Ptr, ByVal pUnknown As Dword, ByRef RefIID As Guid, ByVal ppv As Dword Ptr) As Long
  Local strIXStr, strIYStr As String
  Local pIX As I_X Ptr
  Local pCC As CC Ptr
  Local hr  As Long

  Print "Called CCClassFactory_CreateInstance()"
  @ppv=%NULL
  If pUnknown Then
     hr=%CLASS_E_NOAGGREGATION
     Exit Function
  Else
     If RefIID=$IID_IUnknown Or RefIID=$IID_IX Or RefIID=$IID_IY Then
        pCC=CoTaskMemAlloc(SizeOf(CC))
        If pCC Then
           Print "  pCC      ="pCC
           @pCC.lpIX=VarPtr(IX_Vtbl)               
           @pCC.lpIY=VarPtr(IY_Vtbl)
           Print "  @pCC.lpIX=" @pCC.lpIX          
           Print "  @pCC.lpIY=" @pCC.lpIY 
           Print
           Print " " Varptr(@pCC.lpIX), @pCC.lpIX  
           Print " " Varptr(@pCC.lpIY), @pCC.lpIY  
           Print
           strIXStr="Default IX Interface String"  
           strIYStr="Default IY Interface String"
           strIXStr=UCode$(strIXStr)               
           strIYStr=UCode$(strIYStr)
           @pCC.m_XText=SysAllocStringLen(Byval Strptr(strIXStr),Len(strIXStr)+1)
           @pCC.m_YText=SysAllocStringLen(Byval Strptr(strIYStr),Len(strIYStr)+1)
           @pCC.m_iXInt=0     :   @pCC.m_iYInt=0   :    @pCC.m_cRef=0
           pIX=pCC
           hr= IX_QueryInterface(pIX,RefIID,ppv)
           Print "  pCC  = " pCC
           Print "  pIX  = " pIX
           Print "  @ppv = " @ppv
           If SUCCEEDED(hr) Then
              Call CCClassFactory_AddRef(this)
              Call CCLock()
           Else
              Call CoTaskMemFree(pCC)
              CCClassFactory_CreateInstance=%E_FAIL
              Print : Print "CreateInstance Failed!"
              Exit Function
           End If
        Else
           hr=%E_OutOfMemory
           Exit Function
        End If
     Else   
        hr=%E_FAIL
        Exit Function
     End If
  End If   
  Print "Leaving CBClassFactory_CreateInstance()"

  CCClassFactory_CreateInstance=%S_Ok
End Function


Function CCClassFactory_LockServer(ByVal this As IClassFactory1 Ptr, Byval flock As Long) As Long
  Print "Called CCClassFactory_LockServer()"
  If flock Then
     Call CCLock()
  Else
     Call CCUnLock()
  End If

  CCClassFactory_LockServer=%NOERROR
End Function


Function ExeRegisterServer(hInstance As Long) As Long
  Local strAsciPath,strWideCharPath As String
  Local hr,iBytesReturned As Long
  Local szPath As Asciiz*256
  Local pTypeLib As ITypeLib
  
  Print "  Entering ExeRegisterServer()"
  If GetModuleFileName(hInstance, szPath, 256) Then
     Print "    szPath         = " szPath
     strAsciPath=szPath
     strWideCharPath=UCode$(strAsciPath & $Nul)
     hr=LoadTypeLibEx(Strptr(strWideCharPath), %REGKIND_REGISTER, pTypeLib)
     If SUCCEEDED(hr) Then
        Print "    LoadTypeLib() Succeeded!"
        'Call pTypeLib.Release()
        Set pTypeLib = Nothing
        hr=RegisterServer(szPath, $CLSID_CC, $LIBID_CCLibrary, g_szFriendlyName, g_szVerIndProgID, g_szProgID)
     Else
        Local dwFlags As Dword
        Local szError As Asciiz*256
        Print "    LoadTypeLib() Failed!"
        iBytesReturned= _
        FormatMessage _
        ( _
          dwFlags, _
          Byval 0, _
          hr, _
          MAKELANGID(%LANG_NEUTRAL, %SUBLANG_DEFAULT), _
          Byval Varptr(szError), _
          256, _
          Byval %NULL _
        )
        Print "    iBytesReturned = " iBytesReturned
        Print "szBuffer           = " szError
     End If
  End If
  Print "  Leaving ExeRegisterServer()"

  Function=hr
End Function


Function ExeUnRegisterServer(hInstance As Long) As Long
  Local hr As Long
  
  Print "  Entering ExeUnregisterServer()"
  hr=UnRegisterTypeLib($LIBID_CCLibrary, 1, 0, %LANG_NEUTRAL, %SYS_WIN32)
  If SUCCEEDED(hr) Then
     Print "    UnRegisterTypeLib() Succeeded!"
     hr=UnregisterServer($CLSID_CC, g_szVerIndProgID, g_szProgID)
  Else
     Print "    UnRegisterTypeLib() Failed!"   
  End If 
  Print "  Leaving ExeUnregisterServer()"
  
  Function=hr
End Function


Function CmdLineProcessing(Byval hInstance As Long, Byval lpCmdLine As Asciiz Ptr, Byref regID As Dword, Byref blnFailure As Long) As Long
  Local hr As Long

  Print "Entering blnCmdLineProcessing()"
  If InStr(@lpCmdLine,"/r") Then
     Print "  Calling ExeRegisterServer()"
     hr=ExeRegisterServer(hInstance)
     If SUCCEEDED(hr) Then
        Print "  ExeRegisterServer() Apparently Succeeded!"
     Else
        Print "  ExeRegisterServer() Apparently Failed!"   
     End If   
     Print "Leaving blnCmdLineProcessing()"
     Print
     Function=%TRUE
     Exit Function
  End If
  If InStr(@lpCmdLine,"/u") Then
     Print "  Calling ExeUnregisterServer()"
     hr=ExeUnregisterServer(hInstance)
     If SUCCEEDED(hr) Then
        Print "  ExeUnregisterServer Apparently Succeeded!"
     Else
        Print "  ExeUnregisterServer Apparently Failed!"
     End If    
     Print "Leaving blnCmdLineProcessing()"
     Print
     Function=%TRUE
     Exit Function
  End If
  If InStr(@lpCmdLine,"/Embedding") Or InStr(@lpCmdLine,"-Embedding") Then
     Print "  Was Loaded By COM!"
     hr=CoRegisterClassObjectPtr($CLSID_CC, Varptr(CCClassFactory), %CLSCTX_LOCAL_SERVER, %REGCLS_MULTIPLEUSE, regID)
     If SUCCEEDED(hr) Then
        Print "  CoRegisterClassObject() Succeeded!"
     Else
        Print "CoRegisterClassObject() Failed!"
        blnFailure=%TRUE
        Local dwFlags As Dword
        Local szError As Asciiz*256
        dwFlags=%FORMAT_MESSAGE_FROM_SYSTEM
        FormatMessage(dwFlags, Byval 0, hr, MAKELANGID(%LANG_NEUTRAL, %SUBLANG_DEFAULT), Byval Varptr(szError), 256, Byval %NULL)
        Print "szBuffer = " szError
    End If
  End If  
  Print "Leaving blnCmdLineProcessing()"
  Print

  Function=%FALSE
End Function


Function Initialize() As Long
  Local pClsFac As Dword Ptr
  Local hr As Long

  Print "Entering Initialize()" 
  g_szFriendlyName                           = "Com Object CC"
  g_szProgID                                 = "ComObject.CC.1"
  g_szVerIndProgID                           = "ComObject.CC"
  IClassFactory_Vtbl.QueryInterface          = CodePtr(CCClassFactory_QueryInterface)
  IClassFactory_Vtbl.AddRef                  = CodePtr(CCClassFactory_AddRef)
  IClassFactory_Vtbl.Release                 = CodePtr(CCClassFactory_Release)
  IClassFactory_Vtbl.CreateInstance          = CodePtr(CCClassFactory_CreateInstance)
  IClassFactory_Vtbl.LockServer              = CodePtr(CCClassFactory_LockServer)
  CCClassFactory.lpVtbl                      = VarPtr(IClassFactory_Vtbl)
  Print "  IClassFactory_Vtbl.QueryInterface = " IClassFactory_Vtbl.QueryInterface
  Print "  IClassFactory_Vtbl.AddRef         = " IClassFactory_Vtbl.AddRef
  Print "  IClassFactory_Vtbl.Release        = " IClassFactory_Vtbl.Release
  Print "  IClassFactory_Vtbl.CreateInstance = " IClassFactory_Vtbl.CreateInstance
  Print "  IClassFactory_Vtbl.LockServer     = " IClassFactory_Vtbl.LockServer
  Print
  Print "  Varptr(CCClassFactory)            = " Varptr(CCClassFactory)
  Print "  Varptr(CCClassFactory.lpVtbl)     = " Varptr(CCClassFactory.lpVtbl)
  Print "  Varptr(IClassFactory_Vtbl)        = " Varptr(IClassFactory_Vtbl)
  Print "  CCClassFactory.lpVtbl             = " CCClassFactory.lpVtbl  
  IX_Vtbl.QueryInterface                     = CodePtr(IX_QueryInterface)
  IX_Vtbl.AddRef                             = CodePtr(IX_AddRef)
  IX_Vtbl.Release                            = CodePtr(IX_Release)
  IX_Vtbl.SetXInt                            = CodePtr(SetXInt)
  IX_Vtbl.GetXInt                            = CodePtr(GetXInt)
  IX_Vtbl.SetXText                           = CodePtr(SetXText)
  IX_Vtbl.GetXText                           = CodePtr(GetXText)
  IY_Vtbl.QueryInterface                     = CodePtr(IY_QueryInterface)
  IY_Vtbl.AddRef                             = CodePtr(IY_AddRef)
  IY_Vtbl.Release                            = CodePtr(IY_Release)
  IY_Vtbl.SetYInt                            = CodePtr(SetYInt)
  IY_Vtbl.GetYInt                            = CodePtr(GetYInt)
  IY_Vtbl.SetYText                           = CodePtr(SetYText)
  IY_Vtbl.GetYText                           = CodePtr(GetYText)
  hr=CCClassFactory_QueryInterface(VarPtr(CCClassFactory), $IID_IClassFactory, Varptr(pClsFac))
  If FAILED(hr) Then
     CCClassFactory.lpVTbl=0
     hr=%CLASS_E_CLASSNOTAVAILABLE
     Exit Function
  Else
     
     Print "  pClsFac = " pClsFac
  End If
  Print "Leaving Initialize()" : Print

  Function=hr
End Function


